diff --git a/bin/date/netdate.c b/bin/date/netdate.c
index c4f01c4..f5e6163 100644
--- a/bin/date/netdate.c
+++ b/bin/date/netdate.c
@@ -137,7 +137,7 @@ loop:
 
 	FD_ZERO(&ready);
 	FD_SET(s, &ready);
-	found = select(FD_SETSIZE, &ready, (fd_set *)0, (fd_set *)0, &tout);
+	found = select(FD_SETSIZE, &ready, NULL, NULL, &tout);
 
 	length = sizeof(errn);
 	if (!getsockopt(s,
diff --git a/bin/sh/miscbltin.c b/bin/sh/miscbltin.c
index 9776879..6420901 100644
--- a/bin/sh/miscbltin.c
+++ b/bin/sh/miscbltin.c
@@ -328,10 +328,10 @@ static const struct limits limits[] = {
 	{ "locked memory",	"kbytes",	RLIMIT_MEMLOCK, 1024, 'l' },
 #endif
 #ifdef RLIMIT_NPROC
-	{ "max user processes",	(char *)0,	RLIMIT_NPROC,      1, 'u' },
+	{ "max user processes",	NULL,		RLIMIT_NPROC,      1, 'u' },
 #endif
 #ifdef RLIMIT_NOFILE
-	{ "open files",		(char *)0,	RLIMIT_NOFILE,     1, 'n' },
+	{ "open files",		NULL,		RLIMIT_NOFILE,     1, 'n' },
 #endif
 #ifdef RLIMIT_VMEM
 	{ "virtual mem size",	"kbytes",	RLIMIT_VMEM,	1024, 'v' },
@@ -343,9 +343,9 @@ static const struct limits limits[] = {
 	{ "sbsize",		"bytes",	RLIMIT_SBSIZE,	   1, 'b' },
 #endif
 #ifdef RLIMIT_POSIXLOCK
-	{ "posixlocks",		(char *)0,	RLIMIT_POSIXLOCK,  1, 'k' },
+	{ "posixlocks",		NULL,		RLIMIT_POSIXLOCK,  1, 'k' },
 #endif
-	{ (char *) 0,		(char *)0,	0,		   0, '\0' }
+	{ NULL,			NULL,		0,		   0, '\0' }
 };
 
 int
diff --git a/bin/sh/trap.c b/bin/sh/trap.c
index a767e9d..9744732 100644
--- a/bin/sh/trap.c
+++ b/bin/sh/trap.c
@@ -319,7 +319,7 @@ getsigaction(int signo, sig_t *sigact)
 {
 	struct sigaction sa;
 
-	if (sigaction(signo, (struct sigaction *)0, &sa) == -1)
+	if (sigaction(signo, NULL, &sa) == -1)
 		return 0;
 	*sigact = (sig_t) sa.sa_handler;
 	return 1;
diff --git a/games/battlestar/com6.c b/games/battlestar/com6.c
index 662c229..945a57b 100644
--- a/games/battlestar/com6.c
+++ b/games/battlestar/com6.c
@@ -121,7 +121,7 @@ post(unsigned int ch)
 
 	s = sigblock(sigmask(SIGINT));
 
-	gettimeofday(&tv, (struct timezone *)0);	/* can't call time */
+	gettimeofday(&tv, NULL);	/* can't call time */
 	tvsec = (time_t) tv.tv_sec;
 	date = ctime(&tvsec);
 	date[24] = '\0';
diff --git a/games/hack/hack.invent.c b/games/hack/hack.invent.c
index c02d57e..bae7718 100644
--- a/games/hack/hack.invent.c
+++ b/games/hack/hack.invent.c
@@ -385,7 +385,7 @@ getobj(const char *let, const char *word)
 			continue;
 		}
 		if(index(quitchars,ilet))
-			return((struct obj *)0);
+			return(NULL);
 		if(ilet == '-') {
 			return(allownone ? &zeroobj : (struct obj *) 0);
 		}
diff --git a/games/hack/hack.main.c b/games/hack/hack.main.c
index 5a42a89..909ba3c 100644
--- a/games/hack/hack.main.c
+++ b/games/hack/hack.main.c
@@ -292,7 +292,7 @@ not_recovered:
 			  (!(Fast & ~INTRINSIC) && (!Fast || rn2(3)))) {
 				movemon();
 				if(!rn2(70))
-				    makemon((struct permonst *)0, 0, 0);
+				    makemon(NULL, 0, 0);
 			}
 			if(Glib) glibr();
 			p_timeout();
diff --git a/games/hack/hack.wizard.c b/games/hack/hack.wizard.c
index f3a04c3..977a174 100644
--- a/games/hack/hack.wizard.c
+++ b/games/hack/hack.wizard.c
@@ -137,7 +137,7 @@ inrange(struct monst *mtmp)
 		    case 0:
 			/* create a nasty monster from a deep level */
 			/* (for the moment, 'nasty' is not implemented) */
-			makemon((struct permonst *)0, u.ux, u.uy);
+			makemon(NULL, u.ux, u.uy);
 			break;
 		    case 1:
 			pline("\"Destroy the thief, my pets!\"");
diff --git a/games/larn/diag.c b/games/larn/diag.c
index 63b1a47..ff8a8b3 100644
--- a/games/larn/diag.c
+++ b/games/larn/diag.c
@@ -32,7 +32,7 @@ diag(void)
 	cursors();  lwclose();
 	if (lcreat(diagfile) < 0)	/*	open the diagnostic file	*/
 		{
-		lcreat((char*)0); lprcat("\ndiagnostic failure\n"); return(-1);
+		lcreat(NULL); lprcat("\ndiagnostic failure\n"); return(-1);
 		}
 
 	write(1,"\nDiagnosing . . .\n",18);
@@ -113,7 +113,7 @@ diag(void)
 	for (i=0; i<16; i++)  { lprintf("  %5d",(long)rndcount[i]); if (i==7) lprc('\n'); }
 
 	lprcat("\n\n");			lwclose();
-	lcreat((char*)0);		lprcat("Done Diagnosing . . .");
+	lcreat(NULL);		lprcat("Done Diagnosing . . .");
 	return(0);
 	}
 /*
@@ -166,7 +166,7 @@ savegame(char *fname)
 	ointerest();
 	if (lcreat(fname) < 0)
 		{
-		lcreat((char*)0); lprintf("\nCan't open file <%s> to save game\n",fname);
+		lcreat(NULL); lprintf("\nCan't open file <%s> to save game\n",fname);
 		nosignal=0;  return(-1);
 		}
 
@@ -198,7 +198,7 @@ savegame(char *fname)
 #ifndef VT100
 	setscroll();
 #endif /* VT100 */
-	lcreat((char*)0);  nosignal=0;
+	lcreat(NULL);  nosignal=0;
 	return(0);
 	}
 
@@ -211,7 +211,7 @@ restoregame(char *fname)
 	cursors(); lprcat("\nRestoring . . .");  lflush();
 	if (lopen(fname) <= 0)
 		{
-		lcreat((char*)0); lprintf("\nCan't open file <%s>to restore game\n",fname);
+		lcreat(NULL); lprintf("\nCan't open file <%s>to restore game\n",fname);
 		nap(2000); c[GOLD]=c[BANKACCOUNT]=0;  died(-265); return;
 		}
 
@@ -265,7 +265,7 @@ restoregame(char *fname)
 	if (strcmp(fname,ckpfile) == 0)
 		{
 		if (lappend(fname) < 0) fcheat();  else { lprc(' '); lwclose(); }
-		lcreat((char*)0);
+		lcreat(NULL);
 		}
 	else if (unlink(fname) < 0) fcheat(); /* can't unlink save file */
 /*	for the greedy cheater checker	*/
diff --git a/games/larn/io.c b/games/larn/io.c
index 5678c84..457ca52 100644
--- a/games/larn/io.c
+++ b/games/larn/io.c
@@ -171,7 +171,7 @@ newgame(void)
 	long *p,*pe;
 	for (p=c,pe=c+100; p<pe; *p++ =0);
 	time(&initialtime);             srandomdev();
-	lcreat((char*)0);	/* open buffering for output to terminal */
+	lcreat(NULL);	/* open buffering for output to terminal */
 	}
 
 /*
@@ -437,7 +437,7 @@ lgetl(void)
  *	lcreat(filename)			Create a new file for write
  *		char *filename;
  *
- *	lcreat((char*)0); means to the terminal
+ *	lcreat(NULL); means to the terminal
  *	Returns -1 if error, otherwise the file descriptor opened.
  */
 int
diff --git a/games/larn/main.c b/games/larn/main.c
index 58c0a25..06e1bd8 100644
--- a/games/larn/main.c
+++ b/games/larn/main.c
@@ -113,7 +113,7 @@ main(int argc, char **argv)
 	inbuffer = malloc((5*MAXIBUF)>>2);	/* output buffer */
 	if ((lpbuf==0) || (inbuffer==0)) died(-285); /* malloc() failure */
 
-	lcreat((char*)0);	newgame();		/*	set the initial clock  */ hard= -1;
+	lcreat(NULL);	newgame();		/*	set the initial clock  */ hard= -1;
 
 #ifdef VT100
 /*
diff --git a/games/larn/scores.c b/games/larn/scores.c
index 807d52a..78bf8a0 100644
--- a/games/larn/scores.c
+++ b/games/larn/scores.c
@@ -112,7 +112,7 @@ readboard(void)
 	if (lopen(scorefile)<0)
 	  { lprcat("Can't read scoreboard\n"); lflush(); return(-1); }
 	lrfill((char*)sco,sizeof(sco));		lrfill((char*)winr,sizeof(winr));
-	lrclose();  lcreat((char*)0);  return(0);
+	lrclose();  lcreat(NULL);  return(0);
 	}
 
 /*
@@ -127,7 +127,7 @@ writeboard(void)
 	if (lcreat(scorefile)<0)
 	  { lprcat("Can't write scoreboard\n"); lflush(); return(-1); }
 	lwrite((char*)sco,sizeof(sco));		lwrite((char*)winr,sizeof(winr));
-	lwclose();  lcreat((char*)0);  return(0);
+	lwclose();  lcreat(NULL);  return(0);
 	}
 
 /*
@@ -293,7 +293,7 @@ void
 showscores(void)
 	{
 	int i,j;
-	lflush();  lcreat((char*)0);  if (readboard()<0) return;
+	lflush();  lcreat(NULL);  if (readboard()<0) return;
 	i=winshou();	j=shou(0);
 	if (i+j == 0) lprcat(esb); else lprc('\n');
 	lflush();
@@ -308,7 +308,7 @@ void
 showallscores(void)
 	{
 	int i,j;
-	lflush();  lcreat((char*)0);  if (readboard()<0) return;
+	lflush();  lcreat(NULL);  if (readboard()<0) return;
 	c[WEAR] = c[WIELD] = c[SHIELD] = -1;  /* not wielding or wearing anything */
 	for (i=0; i<MAXPOTION; i++) potionname[i] = potionhide[i];
 	for (i=0; i<MAXSCROLL; i++) scrollname[i] = scrollhide[i];
@@ -522,7 +522,7 @@ invalid:
 			{
 			if (lcreat(logfile)<0) /* and can't create new log file */
 		    	{
-				lcreat((char*)0);
+				lcreat(NULL);
 				lprcat("\nCan't open record file:  I can't post your score.\n");
 				sncbr();  resetscroll();  lflush();  exit(1);
 				}
@@ -596,7 +596,7 @@ diedlog(void)
 	int n;
 	char *p;
 	struct stat stbuf;
-	lcreat((char*)0);
+	lcreat(NULL);
 	if (lopen(logfile)<0)
 		{
 		lprintf("Can't locate log file <%s>\n",logfile);
@@ -668,7 +668,7 @@ addone:
 	if (lappend(playerids) < 0) return(-1);	/* can't open file for append */
 	lprintf("%d\n%s",(long)++high,name);  /* new id # and name */
 	lwclose();
-	lcreat((char*)0);	/* re-open terminal channel */
+	lcreat(NULL);	/* re-open terminal channel */
 	return(high);
 	}
 #endif /* UIDSCORE */
diff --git a/games/larn/signal.c b/games/larn/signal.c
index 6b72fd1..a69f986 100644
--- a/games/larn/signal.c
+++ b/games/larn/signal.c
@@ -55,7 +55,7 @@ static void
 tstop(void) /* control Y	*/
 	{
 	if (nosignal)   return;  /* nothing if inhibited */
-	lcreat((char*)0);  clearvt100();	lflush();	  signal(SIGTSTP,SIG_DFL);
+	lcreat(NULL);  clearvt100();	lflush();	  signal(SIGTSTP,SIG_DFL);
 #ifdef SIGVTALRM
 	/* looks like BSD4.2 or higher - must clr mask for signal to take effect*/
 	sigsetmask(sigblock(0)& ~BIT(SIGTSTP));
diff --git a/games/rogue/rogue.h b/games/rogue/rogue.h
index 98ff79c..6930f51 100644
--- a/games/rogue/rogue.h
+++ b/games/rogue/rogue.h
@@ -254,8 +254,8 @@ struct obj {				/* comment is monster meaning */
 
 typedef struct obj object;
 
-#define INIT_AW (object*)0,(object*)0
-#define INIT_RINGS (object*)0,(object*)0
+#define INIT_AW NULL,NULL
+#define INIT_RINGS NULL,NULL
 #define INIT_HP 12
 #define INIT_STR 16,16
 #define INIT_EXP 1,0
diff --git a/games/rogue/spec_hit.c b/games/rogue/spec_hit.c
index 7c12aeb..c5b5cc4 100644
--- a/games/rogue/spec_hit.c
+++ b/games/rogue/spec_hit.c
@@ -148,7 +148,7 @@ freeze(object *monster)
 			for (i = 0; i < 50; i++) {
 				mv_mons();
 			}
-			killed_by((object *)0, HYPOTHERMIA);
+			killed_by(NULL, HYPOTHERMIA);
 		}
 		message(you_can_move_again, 1);
 		monster->m_flags &= (~FREEZING_ROGUE);
diff --git a/games/sail/assorted.c b/games/sail/assorted.c
index f26cd73..1d682d9 100644
--- a/games/sail/assorted.c
+++ b/games/sail/assorted.c
@@ -103,7 +103,7 @@ table(int rig, int shot, int hittable,
 		rigg[3] -= rhits;
 	}
 	if (rig && !rigg[2] && (!rigg[3] || rigg[3] == -1))
-		makesignal(on, "dismasted!", (struct ship *)0);
+		makesignal(on, "dismasted!", NULL);
 	if (portside(from, on, 0)) {
 		guns = on->specs->gunR;
 		car = on->specs->carR;
@@ -180,7 +180,7 @@ table(int rig, int shot, int hittable,
 			message = "main topmast and mizzen mast shattered";
 			break;
 		}
-		makesignal(on, message, (struct ship *)0);
+		makesignal(on, message, NULL);
 	} else if (roll == 6) {
 		switch (Hhit) {
 		case 0:
@@ -206,7 +206,7 @@ table(int rig, int shot, int hittable,
 			message = "shot holes below the water line";
 			break;
 		}
-		makesignal(on, message, (struct ship *)0);
+		makesignal(on, message, NULL);
 	}
 	if (!hull)
 		strike(on, from);
diff --git a/games/sail/dr_2.c b/games/sail/dr_2.c
index b7a15f6..79fca21 100644
--- a/games/sail/dr_2.c
+++ b/games/sail/dr_2.c
@@ -98,13 +98,13 @@ checkup(void)
 			foreachship(sq)
 				cleansnag(sp, sq, 1);
 		if (sink != 1) {
-			makesignal(sp, "exploding!", (struct ship *)0);
+			makesignal(sp, "exploding!", NULL);
 			foreachship(sq) {
 				if (sp != sq && sq->file->dir && range(sp, sq) < 4)
 					table(RIGGING, L_EXPLODE, sp->specs->guns/13, sq, sp, 6);
 			}
 		} else
-			makesignal(sp, "sinking!", (struct ship *)0);
+			makesignal(sp, "sinking!", NULL);
 	}
 }
 
diff --git a/games/sail/dr_3.c b/games/sail/dr_3.c
index d4f6a6d..e5a0228 100644
--- a/games/sail/dr_3.c
+++ b/games/sail/dr_3.c
@@ -271,8 +271,7 @@ sendbp(struct ship *from, struct ship *to, int sections, char isdefense)
 		Write(isdefense ? W_DBP : W_OBP, from,
 			n, turn, to->file->index, sections);
 		if (isdefense)
-			makesignal(from, "repelling boarders",
-				(struct ship *)0);
+			makesignal(from, "repelling boarders", NULL);
 		else
 			makesignal(from, "boarding the %s (%c%c)", to);
 	}
diff --git a/games/sail/machdep.h b/games/sail/machdep.h
index 4ce6ad3..d244035 100644
--- a/games/sail/machdep.h
+++ b/games/sail/machdep.h
@@ -42,12 +42,12 @@
 		sigset_t sigset;					\
 		sigemptyset(&sigset);					\
 		sigaddset(&sigset, SIGALRM);				\
-		sigprocmask(SIG_BLOCK, &sigset, (sigset_t *)0);		\
+		sigprocmask(SIG_BLOCK, &sigset, NULL);			\
 	} while (0)
 #define	unblockalarm() \
 	do {								\
 		sigset_t sigset;					\
 		sigemptyset(&sigset);					\
 		sigaddset(&sigset, SIGALRM);				\
-		sigprocmask(SIG_UNBLOCK, &sigset, (sigset_t *)0);	\
+		sigprocmask(SIG_UNBLOCK, &sigset, NULL);		\
 	} while (0)
diff --git a/games/sail/pl_1.c b/games/sail/pl_1.c
index b6f73d5..c689ee4 100644
--- a/games/sail/pl_1.c
+++ b/games/sail/pl_1.c
@@ -58,27 +58,27 @@ leave(int conditions)
 
 	if (done_curses) {
 		Signal("It looks like you've had it!",
-			(struct ship *)0);
+			NULL);
 		switch (conditions) {
 		case LEAVE_QUIT:
 			break;
 		case LEAVE_CAPTURED:
 			Signal("Your ship was captured.",
-				(struct ship *)0);
+				NULL);
 			break;
 		case LEAVE_HURRICAN:
 			Signal("Hurricane!  All ships destroyed.",
-				(struct ship *)0);
+				NULL);
 			break;
 		case LEAVE_DRIVER:
-			Signal("The driver died.", (struct ship *)0);
+			Signal("The driver died.", NULL);
 			break;
 		case LEAVE_SYNC:
-			Signal("Synchronization error.", (struct ship *)0);
+			Signal("Synchronization error.", NULL);
 			break;
 		default:
 			Signal("A funny thing happened (%d).",
-				(struct ship *)0, conditions);
+				NULL, conditions);
 		}
 	} else {
 		switch (conditions) {
@@ -103,7 +103,7 @@ leave(int conditions)
 		write_log(ms);
 		if (conditions != LEAVE_SYNC) {
 			makesignal(ms, "Captain %s relinquishing.",
-				(struct ship *)0, mf->captain);
+				NULL, mf->captain);
 			Write(W_END, ms, 0, 0, 0, 0);
 			Sync();
 		}
@@ -127,7 +127,7 @@ child(void)
 
 	signal(SIGCHLD, SIG_IGN);
 	do {
-		pid = wait3((int *)&status, WNOHANG, (struct rusage *)0);
+		pid = wait3((int *)&status, WNOHANG, NULL);
 		if (pid < 0 || (pid > 0 && !WIFSTOPPED(status)))
 			hasdriver = 0;
 	} while (pid > 0);
diff --git a/games/sail/pl_2.c b/games/sail/pl_2.c
index 0c8b5c1..b512ddb 100644
--- a/games/sail/pl_2.c
+++ b/games/sail/pl_2.c
@@ -43,7 +43,7 @@ play(void)
 	struct ship *sp;
 
 	for (;;) {
-		switch (sgetch("~\b", (struct ship *)0, 0)) {
+		switch (sgetch("~\b", NULL, 0)) {
 		case 'm':
 			acceptmove();
 			break;
@@ -57,7 +57,7 @@ play(void)
 			unfoulplayer();
 			break;
 		case 'v':
-			Signal("%s", (struct ship *)0, version);
+			Signal("%s", NULL, version);
 			break;
 		case 'b':
 			acceptboard();
@@ -75,7 +75,7 @@ play(void)
 			repair();
 			break;
 		case 'B':
-			Signal("'Hands to stations!'", (struct ship *)0);
+			Signal("'Hands to stations!'", NULL);
 			unboard(ms, ms, 1);	/* cancel DBP's */
 			unboard(ms, ms, 0);	/* cancel offense */
 			break;
@@ -91,10 +91,10 @@ play(void)
 			mf->loadR = L_EMPTY;
 			mf->readyL = R_EMPTY;
 			mf->readyR = R_EMPTY;
-			Signal("Broadsides unloaded", (struct ship *)0);
+			Signal("Broadsides unloaded", NULL);
 			break;
 		case 'q':
-			Signal("Type 'Q' to quit", (struct ship *)0);
+			Signal("Type 'Q' to quit", NULL);
 			break;
 		case 'Q':
 			leave(LEAVE_QUIT);
@@ -106,7 +106,7 @@ play(void)
 			break;
 		case 'i':
 			if ((sp = closestenemy(ms, 0, 1)) == 0)
-				Signal("No more ships left.", (struct ship *)0);
+				Signal("No more ships left.", NULL);
 			else
 				eyeball(sp);
 			break;
diff --git a/games/sail/pl_3.c b/games/sail/pl_3.c
index 7c3a42c..b3397d9 100644
--- a/games/sail/pl_3.c
+++ b/games/sail/pl_3.c
@@ -95,7 +95,7 @@ acceptcombat(void)
 			closest, r ? "right" : "left");
 		if (load > L_CHAIN && target < 6) {
 			switch (sgetch("Aim for hull or rigging? ",
-				(struct ship *)0, 1)) {
+				NULL, 1)) {
 			case 'r':
 				shootat = RIGGING;
 				break;
@@ -105,13 +105,13 @@ acceptcombat(void)
 			default:
 				shootat = -1;
 				Signal("'Avast there! Hold your fire.'",
-					(struct ship *)0);
+					NULL);
 			}
 		} else {
-			if (sgetch("Fire? ", (struct ship *)0, 1) == 'n') {
+			if (sgetch("Fire? ", NULL, 1) == 'n') {
 				shootat = -1;
 				Signal("Belay that! Hold your fire.",
-					(struct ship *)0);
+					NULL);
 			} else
 				shootat = RIGGING;
 		}
@@ -193,9 +193,9 @@ acceptcombat(void)
 			table(shootat, load, hit, closest, ms, roll);
 		}
 		Signal("Damage inflicted on the %s:",
-			(struct ship *)0, closest->shipname);
+			NULL, closest->shipname);
 		Signal("\t%d HULL, %d GUNS, %d CREW, %d RIGGING",
-			(struct ship *)0, hhits, ghits, chits, rhits);
+			NULL, hhits, ghits, chits, rhits);
 		if (!r) {
 			mf->loadL = L_EMPTY;
 			mf->readyL = R_EMPTY;
@@ -206,7 +206,7 @@ acceptcombat(void)
 		continue;
 	cant:
 		Signal("Unable to fire %s broadside",
-			(struct ship *)0, r ? "right" : "left");
+			NULL, r ? "right" : "left");
 	}
 	blockalarm();
 	draw_stat();
@@ -231,10 +231,10 @@ grapungrap(void)
 			    || ms->nationality == capship(sp)->nationality) {
 				Write(W_GRAP, ms, sp->file->index, 0, 0, 0);
 				Write(W_GRAP, sp, player, 0, 0, 0);
-				Signal("Attempt succeeds!", (struct ship *)0);
+				Signal("Attempt succeeds!", NULL);
 				makesignal(ms, "grappled with %s (%c%c)", sp);
 			} else
-				Signal("Attempt fails.", (struct ship *)0);
+				Signal("Attempt fails.", NULL);
 			break;
 		case 'u':
 			for (i = grappled2(ms, sp); --i >= 0;) {
@@ -243,13 +243,13 @@ grapungrap(void)
 				    || die() < 3) {
 					cleangrapple(ms, sp, 0);
 					Signal("Attempt succeeds!",
-						(struct ship *)0);
+						NULL);
 					makesignal(ms,
 						"ungrappling with %s (%c%c)",
 						sp);
 				} else
 					Signal("Attempt fails.",
-						(struct ship *)0);
+						NULL);
 			}
 			break;
 		}
@@ -270,10 +270,10 @@ unfoulplayer(void)
 		for (i = fouled2(ms, to); --i >= 0;) {
 			if (die() <= 2) {
 				cleanfoul(ms, to, 0);
-				Signal("Attempt succeeds!", (struct ship *)0);
+				Signal("Attempt succeeds!", NULL);
 				makesignal(ms, "Unfouling %s (%c%c)", to);
 			} else
-				Signal("Attempt fails.", (struct ship *)0);
+				Signal("Attempt fails.", NULL);
 		}
 	}
 }
diff --git a/games/sail/pl_4.c b/games/sail/pl_4.c
index 390c0b9..0549c92 100644
--- a/games/sail/pl_4.c
+++ b/games/sail/pl_4.c
@@ -49,19 +49,19 @@ changesail(void)
 	if (mc->crew3 && rig) {
 		if (!full) {
 			if (sgetch("Increase to Full sails? ",
-				(struct ship *)0, 1) == 'y') {
+				NULL, 1) == 'y') {
 				changed = 1;
 				Write(W_FS, ms, 1, 0, 0, 0);
 			}
 		} else {
 			if (sgetch("Reduce to Battle sails? ",
-				(struct ship *)0, 1) == 'y') {
+				NULL, 1) == 'y') {
 				Write(W_FS, ms, 0, 0, 0, 0);
 				changed = 1;
 			}
 		}
 	} else if (!rig)
-		Signal("Sails rent to pieces", (struct ship *)0);
+		Signal("Sails rent to pieces", NULL);
 }
 
 void
@@ -119,7 +119,7 @@ eyeball(struct ship *ship)
 
 	if (ship->file->dir != 0) {
 		Signal("Sail ho! (range %d, %s)",
-			(struct ship *)0, range(ms, ship), saywhat(ship, 0));
+			NULL, range(ms, ship), saywhat(ship, 0));
 		i = portside(ms, ship, 1) - mf->dir;
 		if (i <= 0)
 			i += 8;
diff --git a/games/sail/pl_5.c b/games/sail/pl_5.c
index fd179d4..2a08803 100644
--- a/games/sail/pl_5.c
+++ b/games/sail/pl_5.c
@@ -55,7 +55,7 @@ acceptmove(void)
 	char *p;
 
 	if (!mc->crew3 || snagged(ms) || !windspeed) {
-		Signal("Unable to move", (struct ship *)0);
+		Signal("Unable to move", NULL);
 		return;
 	}
 
@@ -76,7 +76,7 @@ acceptmove(void)
 				dir = 1;
 			if (last == 't') {
 				Signal("Ship can't turn that fast.",
-					(struct ship *)0);
+					NULL);
 				*p-- = '\0';
 			}
 			last = 't';
@@ -104,7 +104,7 @@ acceptmove(void)
 		case '5': case '6': case '7':
 			if (last == '0') {
 				Signal("Can't move that fast.",
-					(struct ship *)0);
+					NULL);
 				*p-- = '\0';
 			}
 			last = '0';
@@ -116,18 +116,18 @@ acceptmove(void)
 			break;
 		default:
 			if (!isspace(*p)) {
-				Signal("Input error.", (struct ship *)0);
+				Signal("Input error.", NULL);
 				*p-- = '\0';
 			}
 		}
 	if ((ta < 0 && moved) || (vma < 0 && moved)
 	    || (af && turnfirst(buf) && moved)) {
-		Signal("Movement error.", (struct ship *)0);
+		Signal("Movement error.", NULL);
 		if (ta < 0 && moved) {
 			if (mf->FS == 1) {
 				Write(W_FS, ms, 0, 0, 0, 0);
 				Signal("No hands to set full sails.",
-					(struct ship *)0);
+					NULL);
 			}
 		} else if (ma >= 0)
 			buf[1] = '\0';
@@ -136,7 +136,7 @@ acceptmove(void)
 		if (mf->FS == 1) {
 			Write(W_FS, ms, 0, 0, 0, 0);
 			Signal("No hands to set full sails.",
-				(struct ship *)0);
+				NULL);
 		}
 	}
 	if (*buf)
@@ -144,7 +144,7 @@ acceptmove(void)
 	else
 		strcpy(movebuf, "d");
 	Writestr(W_MOVE, ms, movebuf);
-	Signal("Helm: %s.", (struct ship *)0, movebuf);
+	Signal("Helm: %s.", NULL, movebuf);
 }
 
 void
@@ -192,7 +192,7 @@ acceptboard(void)
 	}
 	if (crew[2]) {
 		c = sgetch("How many sections to repel boarders? ",
-			(struct ship *)0, 1);
+			NULL, 1);
 		parties(crew, ms, 1, c);
 	}
 	blockalarm();
@@ -224,7 +224,7 @@ parties(int crew[3], struct ship *to, char isdefense, char buf)
 			}
 			if (buf > '0')
 				Signal("Sending all crew sections.",
-					(struct ship *)0);
+					NULL);
 			Write(isdefense ? W_DBP : W_OBP, ms,
 				j, turn, to->file->index, men);
 			if (isdefense) {
@@ -236,7 +236,7 @@ parties(int crew[3], struct ship *to, char isdefense, char buf)
 						wmove(slot_w, 2, 1 + k);
 				mvwaddstr(slot_w, 3, 0, "DBP");
 				makesignal(ms, "repelling boarders",
-					(struct ship *)0);
+					NULL);
 			} else {
 				wmove(slot_w, 0, 0);
 				for (k=0; k < NBP; k++)
@@ -251,6 +251,6 @@ parties(int crew[3], struct ship *to, char isdefense, char buf)
 			wrefresh(slot_w);
 			unblockalarm();
 		} else
-			Signal("Sending no crew sections.", (struct ship *)0);
+			Signal("Sending no crew sections.", NULL);
 	}
 }
diff --git a/games/sail/pl_6.c b/games/sail/pl_6.c
index ffa702d..adc68e5 100644
--- a/games/sail/pl_6.c
+++ b/games/sail/pl_6.c
@@ -51,10 +51,10 @@ repair(void)
 	? (ptr->x += count, count = 0) : (count -= m - ptr->x, ptr->x = m))
 
 	if (repaired || loaded || fired || changed || turned()) {
-		Signal("No hands free to repair", (struct ship *)0);
+		Signal("No hands free to repair", NULL);
 		return;
 	}
-	c = sgetch("Repair (hull, guns, rigging)? ", (struct ship *)0, 1);
+	c = sgetch("Repair (hull, guns, rigging)? ", NULL, 1);
 	switch (c) {
 		case 'h':
 			repairs = &mf->RH;
@@ -66,7 +66,7 @@ repair(void)
 			repairs = &mf->RR;
 			break;
 		default:
-			Signal("Avast heaving!", (struct ship *)0);
+			Signal("Avast heaving!", NULL);
 			return;
 	}
 	if (++*repairs >= 3) {
@@ -118,7 +118,7 @@ repair(void)
 			break;
 		}
 		if (count == 2) {
-			Signal("Repairs completed.", (struct ship *)0);
+			Signal("Repairs completed.", NULL);
 			*repairs = 2;
 		} else {
 			*repairs = 0;
@@ -151,14 +151,14 @@ loadplayer(void)
 	int loadL, loadR, ready, load;
 
 	if (!mc->crew3) {
-		Signal("Out of crew", (struct ship *)0);
+		Signal("Out of crew", NULL);
 		return;
 	}
 	loadL = mf->loadL;
 	loadR = mf->loadR;
 	if (!loadL && !loadR) {
 		c = sgetch("Load which broadside (left or right)? ",
-			(struct ship *)0, 1);
+			NULL, 1);
 		if (c == 'r')
 			loadL = 1;
 		else
@@ -166,7 +166,7 @@ loadplayer(void)
 	}
 	if ((!loadL && loadR) || (loadL && !loadR)) {
 		c = sgetch("Reload with (round, double, chain, grape)? ",
-			(struct ship *)0, 1);
+			NULL, 1);
 		switch (c) {
 		case 'r':
 			load = L_ROUND;
@@ -186,7 +186,7 @@ loadplayer(void)
 			break;
 		default:
 			Signal("Broadside not loaded.",
-				(struct ship *)0);
+				NULL);
 			return;
 		}
 		if (!loadR) {
diff --git a/games/sail/pl_7.c b/games/sail/pl_7.c
index bc2696c..93475e1 100644
--- a/games/sail/pl_7.c
+++ b/games/sail/pl_7.c
@@ -216,7 +216,7 @@ sgetstr(const char *pr, char *buf, int n)
 	int c;
 	char *p = buf;
 
-	prompt(pr, (struct ship *)0);
+	prompt(pr, NULL);
 	sc_buf = buf;
 	for (;;) {
 		*p = 0;
diff --git a/games/sail/pl_main.c b/games/sail/pl_main.c
index 04ba3e6..e0a0b26 100644
--- a/games/sail/pl_main.c
+++ b/games/sail/pl_main.c
@@ -51,7 +51,7 @@ pl_main(void)
 		exit(1);
 	}
 	initialize();
-	Signal("Aye aye, Sir", (struct ship *)0);
+	Signal("Aye aye, Sir", NULL);
 	play();
 	return 0;			/* for lint,  play() never returns */
 }
diff --git a/lib/libatm/ip_addr.c b/lib/libatm/ip_addr.c
index 3acdd1f..5dc5246 100644
--- a/lib/libatm/ip_addr.c
+++ b/lib/libatm/ip_addr.c
@@ -88,7 +88,7 @@ get_ip_addr(char *p)
 		 * IP address is in dotted decimal format
 		 */
 		if ((sin.sin_addr.s_addr = inet_addr(p)) == -1) {
-			return((struct sockaddr_in *)0);
+			return(NULL);
 		}
 	} else {
 		/*
@@ -97,7 +97,7 @@ get_ip_addr(char *p)
 		ip_host = gethostbyname(p);
 		if (!ip_host ||
 				ip_host->h_addrtype != AF_INET) {
-			return((struct sockaddr_in *)0);
+			return(NULL);
 		}
 		sin.sin_addr.s_addr = *(u_long *)ip_host->h_addr_list[0];
 	}
diff --git a/lib/libatm/timer.c b/lib/libatm/timer.c
index fdf070e..a5abc85 100644
--- a/lib/libatm/timer.c
+++ b/lib/libatm/timer.c
@@ -204,7 +204,7 @@ init_timer(void)
 	timeval.it_interval.tv_usec = 0;
 
 	if (setitimer(ITIMER_REAL, &timeval,
-			(struct itimerval *)0) == -1) {
+			NULL) == -1) {
 		rc = errno;
 		(void)signal(SIGALRM, SIG_DFL);
 	}
diff --git a/lib/libc/citrus/modules/citrus_iso2022.c b/lib/libc/citrus/modules/citrus_iso2022.c
index 6416c8a..d7e2d66 100644
--- a/lib/libc/citrus/modules/citrus_iso2022.c
+++ b/lib/libc/citrus/modules/citrus_iso2022.c
@@ -1176,7 +1176,7 @@ sideok:
 	len = (size_t)(p - tmp);
 	if (n < len) {
 		if (result)
-			*result = (char *)0;
+			*result = NULL;
 		*nresult = (size_t)-1;
 		return E2BIG;
 	}
diff --git a/lib/libc/gen/err.c b/lib/libc/gen/err.c
index 0adf101..be9829e 100644
--- a/lib/libc/gen/err.c
+++ b/lib/libc/gen/err.c
@@ -96,7 +96,7 @@ void
 verrc(int eval, int code, const char *fmt, va_list ap)
 {
 	if (err_file == 0)
-		err_set_file((FILE *)0);
+		err_set_file(NULL);
 	fprintf(err_file, "%s: ", getprogname());
 	if (fmt != NULL) {
 		vfprintf(err_file, fmt, ap);
@@ -121,7 +121,7 @@ void
 verrx(int eval, const char *fmt, va_list ap)
 {
 	if (err_file == 0)
-		err_set_file((FILE *)0);
+		err_set_file(NULL);
 	fprintf(err_file, "%s: ", getprogname());
 	if (fmt != NULL)
 		vfprintf(err_file, fmt, ap);
@@ -160,7 +160,7 @@ void
 vwarnc(int code, const char *fmt, va_list ap)
 {
 	if (err_file == 0)
-		err_set_file((FILE *)0);
+		err_set_file(NULL);
 	fprintf(err_file, "%s: ", getprogname());
 	if (fmt != NULL) {
 		vfprintf(err_file, fmt, ap);
@@ -182,7 +182,7 @@ void
 vwarnx(const char *fmt, va_list ap)
 {
 	if (err_file == 0)
-		err_set_file((FILE *)0);
+		err_set_file(NULL);
 	fprintf(err_file, "%s: ", getprogname());
 	if (fmt != NULL)
 		vfprintf(err_file, fmt, ap);
diff --git a/lib/libc/gen/getnetgrent.c b/lib/libc/gen/getnetgrent.c
index 76746b3..10baa89 100644
--- a/lib/libc/gen/getnetgrent.c
+++ b/lib/libc/gen/getnetgrent.c
@@ -135,7 +135,7 @@ static struct {
 	NULL,
 	NULL,
 };
-static FILE *netf = (FILE *)0;
+static FILE *netf = NULL;
 static int parse_netgrp(const char *);
 static struct linelist *read_for_group(const char *);
 
@@ -160,7 +160,7 @@ setnetgrent(const char *group)
 	if (group == NULL || !strlen(group))
 		return;
 
-	if (grouphead.gr == (struct netgrp *)0 ||
+	if (grouphead.gr == NULL ||
 		strcmp(group, grouphead.grname)) {
 		endnetgrent();
 #ifdef YP
@@ -250,10 +250,10 @@ endnetgrent(void)
 		free(olp->l_line);
 		free((char *)olp);
 	}
-	linehead = (struct linelist *)0;
+	linehead = NULL;
 	if (grouphead.grname) {
 		free(grouphead.grname);
-		grouphead.grname = (char *)0;
+		grouphead.grname = NULL;
 	}
 	gp = grouphead.gr;
 	while (gp) {
@@ -267,7 +267,7 @@ endnetgrent(void)
 			free(ogp->ng_str[NG_DOM]);
 		free((char *)ogp);
 	}
-	grouphead.gr = (struct netgrp *)0;
+	grouphead.gr = NULL;
 #ifdef YP
 	_netgr_yp_enabled = 0;
 #endif
@@ -430,8 +430,8 @@ parse_netgrp(const char *group)
 			break;
 		lp = lp->l_next;
 	}
-	if (lp == (struct linelist *)0 &&
-	    (lp = read_for_group(group)) == (struct linelist *)0)
+	if (lp == NULL &&
+	    (lp = read_for_group(group)) == NULL)
 		return (1);
 	if (lp->l_parsed) {
 #ifdef DEBUG
@@ -541,7 +541,7 @@ read_for_group(const char *group)
 					strlen(group), &result, &resultlen)) {
 				free(result);
 				if (_use_only_yp)
-					return ((struct linelist *)0);
+					return (NULL);
 				else {
 					_netgr_yp_enabled = 0;
 					continue;
diff --git a/lib/libc/gen/getvfsbyname.c b/lib/libc/gen/getvfsbyname.c
index 23b6d2b..d79605f 100644
--- a/lib/libc/gen/getvfsbyname.c
+++ b/lib/libc/gen/getvfsbyname.c
@@ -55,14 +55,14 @@ getvfsbyname(const char *fsname, struct vfsconf *vfcp)
 	name[1] = VFS_GENERIC;
 	name[2] = VFS_MAXTYPENUM;
 	buflen = sizeof(maxtypenum);
-	if (sysctl(name, 3, &maxtypenum, &buflen, (void *)0, (size_t)0) < 0)
+	if (sysctl(name, 3, &maxtypenum, &buflen, NULL, (size_t)0) < 0)
 		return (-1);
 
 	name[2] = VFS_CONF;
 	buflen = sizeof(*vfcp);
 	for (cnt = 0; cnt < maxtypenum; cnt++) {
 		name[3] = cnt;
-		if (sysctl(name, 4, vfcp, &buflen, (void *)0, (size_t)0) < 0) {
+		if (sysctl(name, 4, vfcp, &buflen, NULL, (size_t)0) < 0) {
 			if (errno == EOPNOTSUPP)
 				continue;
 			return (-1);
diff --git a/lib/libc/gen/getvfsent.c b/lib/libc/gen/getvfsent.c
index 96d589d..eaa6742 100644
--- a/lib/libc/gen/getvfsent.c
+++ b/lib/libc/gen/getvfsent.c
@@ -31,7 +31,7 @@ initvfs(void)
 	size_t size = 0;
 	int rv;
 
-	rv = sysctl(mib, 2, (void *)0, &size, (void *)0, (size_t)0);
+	rv = sysctl(mib, 2, NULL, &size, NULL, (size_t)0);
 	if(rv < 0)
 		return 0;
 
@@ -41,7 +41,7 @@ initvfs(void)
 	if(!_vfslist)
 		return 0;
 
-	rv = sysctl(mib, 2, _vfslist, &size, (void *)0, (size_t)0);
+	rv = sysctl(mib, 2, _vfslist, &size, NULL, (size_t)0);
 	if(rv < 0) {
 		free(_vfslist);
 		_vfslist = 0;
diff --git a/lib/libc/gen/popen.c b/lib/libc/gen/popen.c
index 4cd8239..33682d1 100644
--- a/lib/libc/gen/popen.c
+++ b/lib/libc/gen/popen.c
@@ -175,7 +175,7 @@ pclose(FILE *iop)
 	fclose(iop);
 
 	do {
-		pid = _wait4(cur->pid, &pstat, 0, (struct rusage *)0);
+		pid = _wait4(cur->pid, &pstat, 0, NULL);
 	} while (pid == -1 && errno == EINTR);
 
 	/* Remove the entry from the linked list. */
diff --git a/lib/libc/gen/siginterrupt.c b/lib/libc/gen/siginterrupt.c
index a6ed2bb..56dc8c3 100644
--- a/lib/libc/gen/siginterrupt.c
+++ b/lib/libc/gen/siginterrupt.c
@@ -52,7 +52,7 @@ siginterrupt(int sig, int flag)
 	struct sigaction sa;
 	int ret;
 
-	if ((ret = _sigaction(sig, (struct sigaction *)0, &sa)) < 0)
+	if ((ret = _sigaction(sig, NULL, &sa)) < 0)
 		return (ret);
 	if (flag) {
 		sigaddset(&_sigintr, sig);
@@ -61,5 +61,5 @@ siginterrupt(int sig, int flag)
 		sigdelset(&_sigintr, sig);
 		sa.sa_flags |= SA_RESTART;
 	}
-	return (_sigaction(sig, &sa, (struct sigaction *)0));
+	return (_sigaction(sig, &sa, NULL));
 }
diff --git a/lib/libc/gen/time.c b/lib/libc/gen/time.c
index b73d978..fd9ca8f 100644
--- a/lib/libc/gen/time.c
+++ b/lib/libc/gen/time.c
@@ -42,7 +42,7 @@ time(time_t *t)
 {
 	struct timeval tt;
 
-	if (gettimeofday(&tt, (struct timezone *)0) < 0)
+	if (gettimeofday(&tt, NULL) < 0)
 		return(-1);
 	if (t)
 		*t = tt.tv_sec;
diff --git a/lib/libc/gen/times.c b/lib/libc/gen/times.c
index 7c7518a..3596621 100644
--- a/lib/libc/gen/times.c
+++ b/lib/libc/gen/times.c
@@ -59,7 +59,7 @@ times(struct tms *tp)
 		return ((clock_t)-1);
 	tp->tms_cutime = CONVTCK(ru.ru_utime);
 	tp->tms_cstime = CONVTCK(ru.ru_stime);
-	if (gettimeofday(&t, (struct timezone *)0))
+	if (gettimeofday(&t, NULL))
 		return ((clock_t)-1);
 	return ((clock_t)(CONVTCK(t)));
 }
diff --git a/lib/libc/gen/wait.c b/lib/libc/gen/wait.c
index c5eca6e..4469b6b 100644
--- a/lib/libc/gen/wait.c
+++ b/lib/libc/gen/wait.c
@@ -46,7 +46,7 @@
 pid_t
 __wait(int *istat)
 {
-	return (_wait4(WAIT_ANY, istat, 0, (struct rusage *)0));
+	return (_wait4(WAIT_ANY, istat, 0, NULL));
 }
 
 __weak_reference(__wait, wait);
